/*******************************************************************
 *
 * Copyright (C) SAP AG, 2003
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Contact: SAP AG, Neurottstrasse 16, D-69190 Walldorf, GERMANY
 *
 ********************************************************************
 *
 * reference implementation of <uchar.h>
 * JTC1/SC22/WG14 
 * PDTR 19769
 * suggested C standard extension for unicode character types
 *
 ******************************************************************/


#ifndef _UCHAR_H

/* data types char16_t and char32_t */
#if __STDC_VERSION__ >= 199901L 
  #include <stdint.h>
  typedef uint_least_16t char16_t;
  typedef uint_least_32t char32_t;
  #define _RESTRICT restrict
#else
  typedef unsigned short char16_t;
  typedef unsigned int char32_t;
  #define _RESTRICT 
#endif 

/* conversion functions multibyte <-> char16_t/char32_t */
#include <wchar.h> /* for mbstate_t, size_t */

size_t 
mbrtoc16(char16_t * _RESTRICT pc16, const char * _RESTRICT s, size_t n, mbstate_t * _RESTRICT ps);

size_t 
c16rtomb(char * _RESTRICT s, char16_t c16, mbstate_t * _RESTRICT ps);

size_t 
mbrtoc32(char32_t * _RESTRICT pc32, const char * _RESTRICT s, size_t n, mbstate_t * _RESTRICT ps);

size_t 
c32rtomb(char * _RESTRICT s, char32_t c32, mbstate_t * _RESTRICT ps);

#define _UCHAR_H
#endif
